/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
function Action(fld, props){
	this.isRun=false;
	this.timeCritical=false;
	
	this.field=fld;
	this.charas=(props && props.charas)?props.charas:[];
	
	var talkInterval=0;
	var talkFinished=0;

	/****/
	this.Init=function(){
		
	};
	/****/
	this.Destroy=function(){
	};
	
	/****/
	this.Stop=function(){
		this.isRun=false;
		this.field.Stop();
		return this;
	};

	/****
	トークのメインフロー
	setInterval()での呼び出し
	****/
	this.Run=function(){
		var now=(new Date()).getTime();
		var interval;
		if(talkInterval){
			var interval=now-talkInterval; //前回の呼び出しから何ミリ秒経ったか
			if(interval < B_LETTER_INTERVAL){
				return this;
			}
		}
		talkInterval=now;

		this.isRun=this.field.Play(interval);
		
		if(this.isRun){
			talkFinished=0;
		}else if(talkFinished==0){
			talkFinished=now;
		}else if(now-talkFinished >= B_CLOSE_INTERVAL){
			this.Talk(CHARA_INITIALIZE);
			return false;
		}
		
		return this;
	};
	
	/****
	AIトークの開始
	****/
	this.Talk=function(msg){

		if(this.isRun) // 会話中なら終了
			return this;
		talkFinished=0;
		this.field.Start(SsToHtml(msg));
		return this;
	};

	/******/
	function SsToHtml(src){
		var ret=[];
		
		//本文中の \\ を削除
		var tmp=src.replace(/\n/g, '').replace(/\\n/g, '\n').split('\\');

		// srcの1文字目が\だった場合、tmpの1行目を削除
		if(tmp && tmp[0].length==0)
			tmp.shift();

		for(var i=0;i<tmp.length;i++){
			tmp[i]='\\'+tmp[i];
		}
		// スクリプトコマンドを分離
		var re=new RegExp(/(\\_?\w(\[.+?\])?)([\s\S]*)/);
		re.multiline=false;
		for(var i=0,t;i<tmp.length;i++){
			t=re.exec(tmp[i]);
			//t=tmp[i].match(re);
			if(t){
				ret.push(t[1]);
				if(t[3].length)
					ret.push(t[3]);
			}else{
				ret.push(tmp[i]);
			}
		}

		// 実体参照、数値参照を文字に変換
		for(var i=0;i<ret.length;i++){
			src=ret[i];
			tmp='';
			while(src){
				var p=src.match(/([^&]*)(&([^;]+);)(.*)/, 's');
				if(!p){
					tmp+=src;
					src=null;
				}else{
					tmp+=p[1];
					var n=(p[3].indexOf('#')!=-1)?p[3].substring(1):U.entities[p[3]];
					tmp+=n?String.fromCharCode(n):'';
					src=p[4];
				}
			}
			ret[i]=tmp;
		}

		src=tmp=null;
		
		return ret;
	};//

/*********/
	this.toString=function(){
		return 'Action '+this.isRun;
	}

};//Action

