/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
/*****/
function Charactor(id, name, data, fld, bfld){
	this.id=id;
	this.name=name||id;

	this.defaultPose=-1; //デフォルトポーズ
	this.isAnim=false;

	var self=this;

	var cvs;
		cvs=U.CE('img');
		cvs.style.position='absolute';
		cvs.style.top='0px';
		cvs.style.bottom='auto';
		cvs.style.left='0px';
		cvs.style.right='auto';
		cvs.style.visibility='hidden';
		cvs.src=SPACER_URI;
		cvs.title=name;
	if(fld)
		fld.appendChild(cvs);
	
	var postures={}; // id => posture
	var _postures={}; // name => posture
	var pose=-1;//表示中のポーズ

	if(!data)
		data='';
	
	var baseX=0;
	var baseY=0;
	var boxNow={
		x:0,
		y:0,
		w:-1,
		h:-1,
		deg:0,
		flipV:false,
		flipH:false
	};
	
	Isolate.call(this, id, data);

	var balloon=new Balloon(bfld, this, '', null);
	
/****/
	function Isolate(id, data){
		var baseurl=AJAX_OTOGI_URL+id+'/';
		var ps=data.split('\n');
		var tmp=ps[0].split(',');
		boxNow.x=baseX=Number(tmp[0]);
		boxNow.y=baseY=Number(tmp[1]);
		pose=this.defaultPose=Number(ps[1]);
		
		// ps[2]以降はポーズ
		for(var i=2,p;i<ps.length;i++){
			if(!ps[i].length)continue;
			eval('p='+ps[i]+';');
			postures[p.id]=new Posture(p.id, p.src, baseurl, p);
			_postures[p.name]=[p.id];
			p=null;
		}//for

		//defaultPose、の画像をロード
		tmp=(pose==-1)?0:pose;
		if(postures[tmp]) //ポーズ未登録キャラのチェック
			postures[tmp].Loaded();

	};//

	/****/
	this.Destroy=function(){
		for(var i in postures)
			postures[i]=null;
		delete self;
	};
	
	this.Loaded=function(id){
		if(id!==undefined && id!==null)
			if(isNaN(id))
				id=(_postures[id])?_postures[id]:0;
			return (!!postures[id])?postures[id].Loaded():true;
		
		for(var i in postures)
			if(!postures[i].Loaded())
				return false;
		return true;
	};
	
	/****/
	this.N2Id=function(n){
		if(n==this.name)
			return this.id;
		return false;
	};
	
/*************
*************/
	this.GetPos=function(){
		var p=postures[pose];
		return p.GetPos();
	}

/*************
*************/
	this.ZIndex=function(idx){
		if(idx!=undefined)
			cvs.style.zIndex=idx;
		return cvs.style.zIndex;
	};//

/*************
\s[0]

this.charas[this.focus].SetPose(tmp[1]);
*************/
	this.SetPose=function(pid){
		if(pid=='-1'){
			cvs.style.visibility='hidden';
			pose=-1;
			return this;
		}else if(pid!=undefined && isNaN(pid)){
			pose=(_postures[pid])?_postures[pid]:0;

		}else if(pid==undefined || !postures[pid]){
			pose=0;

		}else{
			pose=pid;
		}

		cvs.style.visibility='visible';
		if(!postures[pose])
			pose=this.defaultPose;
		if(!postures[pose])
			return this;
		postures[pose].Draw(cvs, boxNow, this.isAnim);

		this.SetBalloon(false);

		return this;
	};//
/**
トーク開始
s: 台詞
cl: 吹き出しをクリアするか
**/
	this.StartTalk=function(s, cl){
		balloon.Show(cl);
		this.SetBalloon(true);
		balloon.Serif(s);
		return this;
	};//

/****
吹き出しに１文字追加
ポーズアニメーション

停止中：
ポーズアニメーション：実行
移動アニメーション：停止
吹き出し：停止
****/
/**** jQuery.animate()のタイマーが独立しているため、this.isAnimに応じてTalkを停止するタイプに戻す ****/
	this.Talk=function(quick){
		var isStop=(U.EI('stopplay').isStop=='1');

		//	台詞;
		var b=balloon?balloon.Run(quick):false;
		
		// アニメーションに合わせてバルーン位置調整
		this.SetBalloon(false);

		//アニメーション
		if(!postures[pose])
			return (b || this.isAnim);
		var a=(pose==-1)?false:postures[pose].Anim(cvs, boxNow, this.isAnim);
		
		return (b || a || this.isAnim);
	};

/****
ポーズアニメーション
****/
	this.Animate=function(d){
	};

/****/
	this.SetBalloon=function(toTop){
		var xy=U.GetPos(cvs);
		var bsz=balloon.GetSize();

		xy[1]-=bsz.h;
		xy[0]+=U.GetSize(cvs).w*.5-bsz.w*.5;
		
		if(xy[0]<0) xy[0]=0;
		if(xy[0]+bsz.w>FIELD_WIDTH) xy[0]=FIELD_WIDTH-bsz.w;
		if(xy[1]<0) xy[1]=0;
		if(xy[1]+bsz.h>FIELD_HEIGHT) xy[1]=FIELD_HEIGHT-bsz.h;

		if(toTop){
			balloon.MoveTop();
		}
		balloon.MoveTo(xy[0],xy[1]);

		return this;
	};//

/****/
	this.CloseBalloon=function(){
		balloon.Close();
		return this;
	};//
/****/
	this.ClearBalloon=function(){
		balloon.Clear();
		return this;
	};//
	
/*************/
	this.Draw=function(){
		if(!postures[pose])
			return this;
		postures[pose].Draw(cvs, boxNow, this.isAnim);

		this.SetBalloon(false);
		return this;
	};

/*************/
	this.Move=function(mode, arg){
		var key=arg.split(',');
		var t=100*Number(key[0]);
		var x=key[1], y=key[2], z=key[3];

		if(x==undefined||x=='')
			x=(mode=='default')?baseX:boxNow.x;
		if(y==undefined||y=='')
			y=(mode=='default')?baseY:boxNow.y;
		boxNow.x=x;
		boxNow.y=y;

		if(z==undefined||z==''){
			if(mode=='default'){
				//初期サイズへリサイズ
				boxNow.w=boxNow.h=-1;
			}else{
				//現在サイズなので何もしない
			}
		}else if(z.indexOf('%')!=-1){
			z=parseInt(z);
			if(!isNaN(z)){
				boxNow.w=parseInt(w*z*0.1);
				boxNow.h=parseInt(h*z*0.1);
			}
			
		}else if(z.indexOf('h')!=-1){
			z=parseInt(z);
			if(!isNaN(z)){
				boxNow.w=parseInt(w*(z/h));
				boxNow.h=z;
			}
		}else{// if(z.indexOf('w')!=-1){
			z=parseInt(z);
			if(!isNaN(z)){
				boxNow.h=parseInt(h*(z/w));
				boxNow.w=z;
			}
		}
		if(t){
			this.isAnim=true;
			var sz={left:boxNow.x+'px', top: boxNow.y+'px'}
			if(boxNow.w!=-1)
				sz.width=boxNow.w+'px';
			if(boxNow.h!=-1)
				sz.height=boxNow.h+'px';
			$(cvs).animate(sz, t, function(){self.isAnim=false;});
		}else{
			this.Draw();
		}
		return this;
	};//

/****
回転:ノーマル版は未対応
****/
	this.Rotate=function(){
	};
/****
反転:ノーマル版は未対応
****/
	this.Flip=function(){
	};
/****
回転、反転を戻す。
ノーマル版は未対応
****/
	this.Restore=function(){
	};


/*************/
	this.Click=function(e){
		onDrag=false;
		if(!postures[pose])
			return this;

		// e.x, e.pageX, e.clientXはドキュメントの絶対位置、po[0]はstageからの相対位置
		var po=U.GetPos(cvs); po[0]+=90;
		var x=(e.x||e.pageX||e.clientX||0)-po[0];
		var y=(e.y||e.pageY||e.clientY||0)-po[1];

		var region=postures[pose].HitTest(x, y);
		if(region){
			return false;//HITした場合はfalseを返してブラウザの処理を停止する
		}
		return true; //HITしない
	};//

/*************/
	this.OnMouseMove=function(e){
		if(!e)e=window.event;
		var tar=e.target||e.srcElement;
		var po=U.GetPos(tar);
		if(onDrag){
			var x=(e.x||e.pageX||e.clientX||0)-po[0];
			var y=(e.y||e.pageY||e.clientY||0)-po[1];
			this.style.top=(dragpos.y-y)+'px';
			this.style.left=(dragpos.x-x)+'px'
			dragpos.x=e.x||e.pageX;
			dragpos.y=e.y||e.pageY;
			return this;
		}
		if(!postures[pose])
			return this;
		var x=(e.x||e.pageX||e.clientX||0)-po[0];
		var y=(e.y||e.pageY||e.clientY||0)-po[1];
		var region=postures[pose].HitTest(x, y);
		
		return this;
	};//

/*************/
	this.OnMouseDown=function(e){
		onDrag=true;
		dragpos.x=e.x||e.pageX||e.clientX||0;
		dragpos.y=e.y||e.pageY||e.clientY||0;
		return this;
	};//

/*************/
	this.OnMouseUp=function(){
		if(!onDrag)
			return this;
		onDrag=false;
		var x=(e.x||e.pageX||e.clientX||0)-po[0];
		var y=(e.y||e.pageY||e.clientY||0)-po[1];
		this.style.top=(dragpos.y-y)+'px';
		this.style.left=(dragpos.x-x)+'px'
		return this;
	};//

/*************/
	this.toString=function(){
		return 'chara:'+this.id+':'+this.name+';';
	};//

};//


