/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
function Field(id, className, opts){
//初期設定など
	this.id=id||'';		// フィールドID, out-WP
	this.name=id||'';
	this.className=className||'';

//以降、動的に変更されるプロパティ
	this.field=null;
	this.board=null;
	this.charas={};
	this.focus=0;
	this.panels={};
	this.onomas={};
	
	this.tm=0; // action timer

	this.loaded=false;
	
	
	// wait フラグ
	this.animWait=false; // アニメーション
	this.isBoard=false; // board拡大中ならtrue、SS停止
	this.isRun=false;

	this.talkWait=0;
	//this.withClear=true;
	
	this.script=[];
	this.lastScript=[];
	this.sLine=-1; // script line
	this.lastAction={
			talktime:0
		};
	this.scenes={};
	this.defaultscene=0;

/****
	キャラクターを登場させる
****/
	this.Show=function(cha, pos){
		this.field.insertBefore(cha, null);
		return this;
	};//
	
	this.Remove=function(cha){
		delete this.field.removeChild(cha);
		return this;
	};//
	
/****/
	this.Destroy=function(){
		if(tm)
			tm=clearInterval(tm);
		RemoveChild(this.field, true);
		this.PanelDelAll();
		this.SceneDelAll();
		this.OnomaDelAll();
		delete this.panels;
		delete this.scenes;
		delete this.onomas;
	};

/****/
	this.PanelDelAll=function(){
		for(var i in this.panels){
			this.panels[i].Destroy();
			this.panels[i]=null;
		}
		this.panels={};
		return this;
	};//

/****/
	this.OnomaDelAll=function(){
		for(var i in this.onomas){
			this.onomas[i].Hide();
		}
		return this;
	};//
/****/
	this.SceneDelAll=function(){
		for(var i in this.scenes){
			this.scenes[i].Destroy();
		}
		return this;
	};//
	
/****/
	this.Load=function(ftype, ctype){
		return this;
	};//
	
/****/
	this.LoadCharas=function(type){
		return this;
	};//


/****/
	this.LoadScene=function(type){
	};//
	
	this.SetZIndex=function(z){
		return this;
	};//

/****
各プロパティの保存処理とか
****/
	this.toString=function(){
		return 'Field:'+this.id;
	};//
	
/****
キャラクターに話させる
****/
	this.Start=function(str){

		this.isRun=true;
		this.lastScript=str;

		this.script=str;
		this.sLine=0;
		this.talkWait=0;
		return true;
	};//

/****
トークの強制終了
****/
	this.Stop=function(){
		this.isRun=false;
		//this.script='';
		this.sLine=-1;
		this.talkWait=0;
		this.isBoard=false;
		return true;
	};//

/****
****/
	this.Play=function(interval){
		
		return true;
	};

/**
\_r[0]
最初に登場させるキャラを初期表示に戻す

**/
	this.ResetAllPose=function(){
		for(var i in this.charas){
			var c=this.charas[i];
			if(c.Move){
				c.Restore();
				c.SetPose(c.defaultPose);
				c.Move('default',',,,100%');
				c.ZIndex('');
			}
		}
		this.focus=0;
		return this;
	};//

/**
\_c
全てのバルーンを消す
**/
	this.CloseAllBalloon=function(){
		for(var i in this.charas){
			var c=this.charas[i];
			if(c.CloseBalloon){
				c.ClearBalloon();
				c.CloseBalloon();
			}
		}
		return this;
	};//

/**
\_b
全てのバルーンを白抜きにする
**/
	this.ClearAllBalloon=function(){
		for(var i in this.charas){
			var c=this.charas[i];
			if(c.ClearBalloon){
				c.ClearBalloon();
			}
		}
		return this;
	};//

/**
\p['name']
**/
	this.Focus=function(cid, fld){
		if(typeof(cid)!='number'){
			for(var i in this.charas){
				if(this.charas[i].name==cid)
					cid=this.charas[i].id;
					break;
			}
		}
		this.focus=cid;
		
		return this;
	};//

/****
フィールドサイズ
****/
	this.GetSize=function(){
		return U.GetSize(this.field);
	}

/**
ボード
\*[]
**/
	this.BoardSet=function(){
		return this;

	};//

/**
シーン
\r[0]
\r[url]
\r[0,x,y]
\r[url,x,y]
\r[-1] シーンを消す
**/
	this.SceneSet=function(src){
		return this;

	};//


/**
パネル
\+[]
**/
	this.PanelSet=function(){
		return this;

	};//

/**
描き文字
\-[]
**/
	this.OnomaSet=function(src){
		return this;
	};//


};//


///////////////////
function Scene(id, src, baseUrl, opts){
	this.id=id;

	this.src=baseUrl+src;
	
	this.props={
		color: 'transparent',
		y:0,
		x:0,
		repeatx: false,
		repeaty: false
	};
	
	if(opts)
	for(var key in opts)
		this.props[key]=opts[key];
}

Scene.prototype.Show=function(fld, x, y){
	fld.style.backgroundImage='url('+this.src+')';
	for(i in this.props){
		fld.style.background[i]=this.props[i];
	}
	if(x!=undefined || y!=undefined){
		x=x?x:0;
		y=y?y:0;
		fld.style.backgroundPosition='('+x+','+y+')';
	}
	fld=null;
	return this;
}
Scene.prototype.Load=function(){
	var img=new Image();
	img.src=this.src;
	return this;
}
Scene.prototype.Loaded=function(){
	var img=new Image();
	img.src=this.src;
	var ok=img.complete;
	delete img;
	return ok;
}
Scene.prototype.Destroy=function(){
	return this;
}
