<?php
/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/

/*********************
管理画面
*********************/

/********/
class OtogiChara {

	var $otogi_dir;
	var $otogi_url;
	
	var $charas=array(
	
		);

	/*******/
	function OtogiChara(){
		$up_dir=wp_upload_dir();
		$this->otogi_dir=$up_dir['basedir'].'/otogi/';
		$this->otogi_url=$up_dir['baseurl'].'/otogi/';

		$cids=explode(',', get_option('otogi-charas', ''));
		for($i=0,$sz=sizeof($cids);$i<$sz;$i++){
			$cid=$cids[$i];
			if($cid=='')
				continue;
			$opt_cid='otogi-c'.$cid;
			$pose_ids=explode(',', get_option($opt_cid.'-postures', '')); // ポーズIDリスト
			
			$this->charas[$cid]= array(
					'id'       => $cid, 
					'name'     => get_option($opt_cid.'-name', ''.$cid),
					'postures' => sizeof($pose_ids),//ポーズ数
					'base'     => explode(',', get_option($opt_cid.'-base', '0,0')), // 立ち位置、centerXの場所が基準
					'posture'  => array(), // ポーズ
					'defaultPose'  => get_option($opt_cid.'-default', '-1'),
				);
			
			// ポーズのsrcリスト
			$posture=array();
			for($k=0,$sz2=sizeof($pose_ids);$k<$sz2;$k++){
				$pid=$pose_ids[$k];
				if($pid=='')
					continue;
				$opt_pid=$opt_cid.'-'.$pid;
				$posture[$pid]=array(
						'id'   => $pid,
						'name' => get_option($opt_pid.'-name', ''),
						'src'  => get_option($opt_pid.'-src', ''),
						'icon' => get_option($opt_pid.'-icon', ''),
						'pole' => explode(',', get_option($opt_pid.'-pole', '0,0')),
					);
			}//for(postures)
			$this->charas[$cid]['posture']=$posture;
			
		}//for(charas)

	}//

	function GetChara($id, $opt){
		return (!isset($this->charas[$id]) || !isset($this->charas[$id][$opt]))?'':$this->charas[$id][$opt];
	}
	
	function SaveAllCharas(){
		foreach($this->charas as $cid=>$chara){
			SaveCharas($cid);
		}
	}
	function SaveChara($cid, $name='', $basex=0, $basey=0, $defaultPose='-1'){
		$cid=intval($cid);
		$basex=intval('0'.$basex);
		$basey=intval('0'.$basey);
		if($cid<0){
			//新規

			// 新しいidを生成
			$cids=array();
			foreach($this->charas as $id=>$value){
				$cids[]=$id;
				if($cid<=$id)
					$cid=$id;
			}
			$cid++;
			$cids[]=$cid;
			$this->charas[$cid]=array(
					'id' => $cid,
					'name' => $name,
					'base' => array($basex, $basey),
					'posture' => array(),
					'defaultPose' => '-1',
				);

			update_option('otogi-charas', implode(',', $cids));

			if(!is_dir($this->otogi_dir.$cid)){
				$up_dir=wp_upload_dir();
				$st=stat($up_dir['basedir']);
				mkdir($this->otogi_dir.$cid, $st[2]&0777, true);
			}
		}else{
			$this->charas[$cid]['id']=$cid;
			$this->charas[$cid]['name']=$name;
			$this->charas[$cid]['defaultPose']=$defaultPose;
		}

		$opt_cid='otogi-c'.$cid;
		
		
		update_option($opt_cid.'-name', $this->charas[$cid]['name']);
		update_option($opt_cid.'-base', implode(',', $this->charas[$cid]['base']) );
		update_option($opt_cid.'-default', $this->charas[$cid]['defaultPose'] );
		return $cid;
	}//

	function SaveStand(){
	
		foreach($this->charas as $cid=>$value){
			$x=$_REQUEST['otogi-stand-'.$cid.'-x'];
			$y=$_REQUEST['otogi-stand-'.$cid.'-y'];

			$this->charas[$cid]['base']=array($x,$y);
			
			$opt_cid='otogi-c'.$cid;
			update_option($opt_cid.'-base', implode(',', $this->charas[$cid]['base']) );
			
		}
		return true;
	}//

	function SavePosture($cid, $pid, $src='', $icon='', $name='', $polex=0, $poley=0, $input='file'){
		if(!isset($cid) || $cid=='' || !isset($pid) || $pid=='')
			return false;

		$cid=intval($cid);
		$pid=intval($pid);
		$polex=intval('0'.$polex);
		$poley=intval('0'.$poley);
		
		if($pid<0){
		//pidマイナスの場合は新規登録

			if(!isset($_FILES[$input])){
				//ファイルなし、エラー
				return -1;
			}

			// 新しいidを生成
			foreach($this->charas[$cid]['posture'] as $id=>$pose){
				if($pid<=$id)
					$pid=$id;
			}
			$pid++;
			
		}else{
		// pidあり、データ更新

		}

		if(isset($_FILES[$input]) && $_FILES[$input]['size']!==0 ){
		// ファイルがアップロードされていれば保存
			if(!is_dir($this->otogi_dir.$cid)){
			// ディレクトリ作成
				$up_dir=wp_upload_dir();
				$st=stat($up_dir['basedir']);
				mkdir($this->otogi_dir.$cid, $st[2]&0777, true);
			}
			
			$info=pathinfo_japanese($_FILES[$input]['name']);
			
			//nameが空白でファイルアップロードなら、ファイル名をnameとする
			if($name==''){
				$name=$info['filename'];
			}
			
			// ファイル名作成
			if($src==''){
				$src=$pid.'.'. (($info['extension']=='')?'png':$info['extension']);
			}else{//if($src=='')
				$tmp=pathinfo_japanese($src);
				$src=$tmp['basename'];
			}

			$uploadfile = $this->otogi_dir.$cid.'/'.$src;
			if(!move_uploaded_file($_FILES[$input]['tmp_name'], $uploadfile)){
				echo '<p><em class="caution">Can not move uploaded file.</em> '.$uploadfile.'</p>';
			}

		}//if(isset($_FILES[$input]))

		if($name=='')
			$name=$this->charas[$cid]['posture'][$pid]['name'];
		if($src=='')
			$src=$this->charas[$cid]['posture'][$pid]['src'];
		if($icon=='')
			$icon=$this->charas[$cid]['posture'][$pid]['icon'];

		$opt_cid='otogi-c'.$cid;
		$opt_pid=$opt_cid.'-'.$pid;

		$this->charas[$cid]['posture'][$pid]['id']=$pid;
		$this->charas[$cid]['posture'][$pid]['name']=$name;
		$this->charas[$cid]['posture'][$pid]['src']=$src;
		$this->charas[$cid]['posture'][$pid]['icon']=$icon;
		$this->charas[$cid]['posture'][$pid]['pole']=array($polex, $poley);

		update_option($opt_pid.'-name', $name);
		update_option($opt_pid.'-pole', $polex.','.$poley );
		update_option($opt_pid.'-src', $src);
		update_option($opt_pid.'-icon', $icon);

		$postures=array();
		foreach($this->charas[$cid]['posture'] as $pid=>$pose){
			if($pose['src']!='')
				$postures[]=$pid;
		}
		update_option($opt_cid.'-postures', implode(',', $postures) );
		return $pid;

	}
	
	function Export(){

		$fname = $this->otogi_dir.'charas.txt';
		
		$fp=fopen($fname, 'w');
		flock($fp, LOCK_EX);

		$boundary='-----------------------------539183122602';
		
		fprintf($fp, "Content-Type: multipart/mixed; charset=\"UTF-8\"; boundary=\"%s\"\r\n", $boundary);
		foreach($this->charas as $cid=>$chara){
			fprintf($fp, "--".$boundary."\r\n");
			fprintf($fp, "Content-Type: text/html; charset=\"UTF-8\";\r\n");
			fprintf($fp, "Content-Disposition: inline; name=\"%s\"; filename=\"%s\";\r\n", $chara['name'], $cid);
			fprintf($fp, "\r\n");
			fprintf($fp, "%d,%d\n", $chara['base'][0], $chara['base'][1]);
			fprintf($fp, $chara['defaultPose']."\n");
			foreach($chara['posture'] as $pid=>$pose){
				fprintf($fp, "{id:'%s',name:'%s',src:'%s',pole:[%d,%d]}\n", 
					$pose['id'], $pose['name'], $pose['src'], $pose['pole'][0], $pose['pole'][1]);
			}
		}
		fprintf($fp, "--".$boundary. "--\r\n");
		fclose($fp);
		return true;
	}
}
?>